myStocksArray = new Array();

function init(){
	// If some Stocks are being saved, they should be read from pereferences (wkn + name?)
	// These should then be available via another dropdown-menu (or in the already existing dropdown)
	readPrefs();
}

function readPrefs(){
	if (window.widget){
		var myStocks = widget.preferenceForKey("stocksArray");
		if (myStocks != undefined && myStocks.length > 0){
			// we have some valid entries...
			var myGroupArray = new Array();
			myGroupArray = myStocks.split(" -*- ");	// Aktien-Eintraege trennen
			for(var i=0;i<myGroupArray.length;i++){
				var myDummyEntries = myGroupArray[i].split(" *-* "); // Einzelne Aktien-Eintraege weiter unterteilen
				myStocksArray[i] = new Array();
				myStocksArray[i][0] = myDummyEntries[0];
				myStocksArray[i][1] = myDummyEntries[1];
				var mySLength = myStocksArray.length-1;
				// insert new Entry into Select-Lists
				var myDummyName = myStocksArray[mySLength][0] + " (" + myStocksArray[mySLength][1] + ")";
				var myDummyWKN = myStocksArray[mySLength][1];
				document.getElementById("sel_stocks").options[mySLength+2] = (new Option(myDummyName,myDummyWKN));
				var myDummyOption = document.getElementById("sel_stocks").options[myStocksArray.length+1];
				var myDummyAttribute = document.createAttribute("id"); myDummyAttribute.nodeValue = myDummyWKN; myDummyOption.setAttributeNode(myDummyAttribute);
				var myDummyAttribute = document.createAttribute("name"); myDummyAttribute.nodeValue = mySLength; myDummyOption.setAttributeNode(myDummyAttribute);
			}
		}
	}
}

function processXMLData(){
	var myUrl = "http://de.finance.yahoo.com/";
	var myWKN = 0;
	var myIndex = document.getElementById("sel_places").selectedIndex;
	var mySwitch = "";	// Maybe not needed anymore ???
	myVal = document.getElementById("sel_places").options[myIndex].value;
	myWKN = document.getElementById("tx_input").value;

	if (String(myWKN).length == 6) {
		myRequestUrl = myUrl + "q?d=v1&s=" + myWKN + "&m=" + myVal;

		document.quotesf.d.value='xl';
		var req = false;
		var myStatus = "OK";
		req = new XMLHttpRequest();
		req.open("GET", myRequestUrl, false);
		req.onreadystatechange=function() {
			if (req.readyState==4){		// only if "OK"
				if (req.status == 200) {
					myStatus = req.responseText;
					buildTable(myStatus);
				} else {
					showStatus("Problem beim Lesen der XML-Daten: " + req.statusText + "\nBitte erneut versuchen!");
				}
			}
		}
		req.send(null);
	} else {
		showStatus('Bitte 6-stellige Eingabe!!!');
	}
}

function selectStock(myNode){
	if (myNode.selectedIndex > 1){
		document.getElementById("tx_input").value = myNode.options[myNode.selectedIndex].value;
		clearGui();
	} else {
		myNode.selectedIndex = 0;
	}
}
function buildTable(myXMLData){
	clearGui();
	if (myXMLData.indexOf("WKN existiert nicht") != -1){
		showStatus("WKN existiert nicht");
	} else {
		var myErgArray = extractData(myXMLData, " |", new Array("title>"," ") );
		myXMLData = myErgArray[0]; myName = myErgArray[1];

		myErgArray = extractData(myXMLData, "</b>", new Array("Letzter Kurs:","<b>") );
		myXMLData = myErgArray[0]; myLKurs = myErgArray[1];

		myErgArray = extractData(myXMLData, "<",		new Array("Kurszeit:",'">') );
		myXMLData = myErgArray[0]; myKurszeit = myErgArray[1];

		myErgArray = extractData(myXMLData, ">",		new Array("nderung:</td>","img") );
		myXMLData = myErgArray[0]; myImgUrl = "<img" + myErgArray[1] + ">";

		myErgArray = extractData(myXMLData, "<",		new Array(">") );
		myXMLData = myErgArray[0]; myAenderung = myErgArray[1] + myImgUrl;

		myErgArray = extractData(myXMLData, "<", new Array("k:",'">'));		
		myXMLData = myErgArray[0]; mySKurs = myErgArray[1];

		myErgArray = extractData(myXMLData, "<", new Array("s:",'">'));		
		myXMLData = myErgArray[0]; myEKurs = myErgArray[1];

		myErgArray = extractData(myXMLData, "<", new Array("e:",'">'));		
		myXMLData = myErgArray[0]; myTSpanne = myErgArray[1];

		myErgArray = extractData(myXMLData, "<", new Array("e:",'">'));		
		myXMLData = myErgArray[0]; myWSpanne = myErgArray[1];

		myErgArray = extractData(myXMLData, "</", new Array("n:",'">'));		
		myXMLData = myErgArray[0]; myVolumen = myErgArray[1];

		myErgArray = extractData(myXMLData, "</", new Array("n:",'">'));		
		myXMLData = myErgArray[0]; myWVolumen = myErgArray[1];

		myErgArray = extractData(myXMLData, "</", new Array(".:",'">'));		
		myXMLData = myErgArray[0]; myKap = myErgArray[1];

		myErgArray = extractData(myXMLData, "</", new Array(">:",'">'));		
		myXMLData = myErgArray[0]; myKGV = myErgArray[1];

		myErgArray = extractData(myXMLData, '"', new Array("img",'"'));		
		myXMLData = myErgArray[0]; myImg = myErgArray[1];

		document.getElementById("tx_Kap").innerHTML = myKap;
		document.getElementById("tx_KGV").innerHTML = myKGV;
		document.getElementById("tx_WVolumen").innerHTML = myWVolumen;
		document.getElementById("tx_WSpanne").innerHTML = myWSpanne;
		document.getElementById("tx_TSpanne").innerHTML = myTSpanne;
		document.getElementById("tx_EKurs").innerHTML = myEKurs;
		document.getElementById("tx_SKurs").innerHTML = mySKurs;
		document.getElementById("tx_Name").innerHTML = myName;
		document.getElementById("tx_LKurs").innerHTML = myLKurs;
		document.getElementById("tx_Kurszeit").innerHTML = myKurszeit;
		document.getElementById("tx_Aenderung").innerHTML = myAenderung;
		document.getElementById("tx_Volumen").innerHTML = myVolumen;
		document.getElementById("img_Kurs").src = myImg;
		
		if ((myStocksArray.join(",")).indexOf(document.getElementById("tx_input").value) != -1){
			document.getElementById("rb_doPrefs").checked = true;
		} else {
			document.getElementById("rb_doPrefs").checked = false;
		}
		showStatus("Alles OK");
	}
}

function extractData(myData, myEndString, myStartString){
	var myStart = 0;
	var i;
	for (i=0;i<myStartString.length;i++){
		myStart = myData.indexOf(myStartString[i], myStart);
	}
	var myEnd = myData.indexOf(myEndString, myStart+1);
	var myErg = myData.slice(myStart+myStartString[i-1].length,myEnd);
	myData = myData.substr(myEnd+1,myData.length)
	return (new Array(myData, myErg));
}

function clearGui(){
	document.getElementById("tx_Kap").innerHTML = "";
	document.getElementById("tx_KGV").innerHTML = "";
	document.getElementById("tx_WVolumen").innerHTML = "";
	document.getElementById("tx_WSpanne").innerHTML = "";
	document.getElementById("tx_TSpanne").innerHTML = "";
	document.getElementById("tx_EKurs").innerHTML = "";
	document.getElementById("tx_SKurs").innerHTML = "";
	document.getElementById("tx_Name").innerHTML = "";
	document.getElementById("tx_LKurs").innerHTML = "";
	document.getElementById("tx_Kurszeit").innerHTML = "";
	document.getElementById("tx_Aenderung").innerHTML = "";
	document.getElementById("tx_Volumen").innerHTML = "";
	document.getElementById("img_Kurs").src = "";
	document.getElementById("tx_Status").innerHTML = "";
}

function doPrefs(myBool){
	if (!myBool){
		// user clicked on "normal" button
		document.getElementById("rb_doPrefs").checked = !(document.getElementById("rb_doPrefs").checked)
	}
	if (document.getElementById("rb_doPrefs").checked){
		// switch stock on (save and insert into lists)
		// Extend Array
		var mySLength = myStocksArray.length;
		myStocksArray[mySLength] = new Array();
		myStocksArray[mySLength][0] = document.getElementById("tx_Name").innerHTML;
		myStocksArray[mySLength][1] = document.getElementById("tx_input").value;
		// insert new Entry into Select-Lists
		var myDummyName = myStocksArray[mySLength][0] + " (" + myStocksArray[mySLength][1] + ")";
		var myDummyWKN = myStocksArray[mySLength][1];
		document.getElementById("sel_stocks").options[mySLength+2] = (new Option(myDummyName,myDummyWKN));
		var myDummyOption = document.getElementById("sel_stocks").options[myStocksArray.length+1];
		var myDummyAttribute = document.createAttribute("id"); myDummyAttribute.nodeValue = myDummyWKN; myDummyOption.setAttributeNode(myDummyAttribute);
		var myDummyAttribute = document.createAttribute("name"); myDummyAttribute.nodeValue = mySLength; myDummyOption.setAttributeNode(myDummyAttribute);
		showStatus("Aktie gespeichert");
		savePrefs();
	} else {
		// switch stock off (delete it from list and save the list/array)
		var myDelNode = document.getElementById(document.getElementById("tx_input").value);
		var myDelPos = myDelNode.name;	myStocksArray.splice(myDelPos,1);
		var myParentNode = myDelNode.parentNode; myParentNode.removeChild(myDelNode);
		showStatus("Aktie entfernt");
		savePrefs();
	}
}

function savePrefs(){
	// Here we have to transform myStocksArray into the right format and saved it into prefs
	var myDummyEntries = new Array();
	for(var i=0;i<myStocksArray.length;i++){
		myDummyEntries[i] = myStocksArray[i].join(" *-* ");
	}
	var myDummyString = myDummyEntries.join(" -*- ");
	widget.setPreferenceForKey(myDummyString,"stocksArray");
}

function fillList(myList,listStart,listEnd){
	for (var i=listStart;i<listEnd;i++){
		document.getElementById(myList).options[i-1] = (new Option(i,i));
	}
}

function findWKN(){
}

function showStatus(myText){
	document.getElementById("tx_Status").innerHTML = myText;
}